#set( $symbol_pound = '#' )
#set( $symbol_dollar = '$' )
#set( $symbol_escape = '\' )
package ${package}.web.infra;

import javax.faces.event.PhaseEvent;
import javax.faces.event.PhaseId;
import javax.faces.event.PhaseListener;

/**
 * このクラスは、リダイレクト後にFacesメッセージを表示させるためのPhaseListener実装です。
 *
 * @author SIToolkit
 *
 */
public class MessagePhaseListener implements PhaseListener {

    /**
     *
     */
    private static final long serialVersionUID = 1L;

    /**
     * 何も処理を行いません。
     * @param event フェーズイベント
     */
    @Override
    public void afterPhase(PhaseEvent event) {
        // NOP
    }

    /**
     * {@code JSFUtils.restoreMessage()}を実行します。
     * @param event フェーズイベント
     * @see JSFUtils${symbol_pound}restoreMessage() 
     */
    @Override
    public void beforePhase(PhaseEvent event) {
        JSFUtils.restoreMessage();
    }

    /**
     * PhaseId.RENDER_RESPONSEを返します。
     * @return PhaseId.RENDER_RESPONSE
     * @see PhaseId
     */
    @Override
    public PhaseId getPhaseId() {
        return PhaseId.RENDER_RESPONSE;
    }
}
