@echo off

set SCRIPT_FILE=%~dp0script\%1.sql
set LOG_FILE=%~dp0log\%1.log

if exist "%SCRIPT_FILE%" (
	del "%SCRIPT_FILE%"
)

if exist "%LOG_FILE%" (
	del "%LOG_FILE%"
)

call :%1

call :log XNvgs܂B
call :log %SCRIPT_FILE%

mysql -h %DB_HOST% -P %DB_PORT% -u %APP_USER% --password=%APP_USER_PASS% %DB% -t < "%SCRIPT_FILE%" > "%LOG_FILE%"

type "%LOG_FILE%"

set ERR=%ERRORLEVEL%
if %ERR%==0 (
	call :log R}h%1ɏI܂B
) else (
	call :log R}h%1ُI܂B
)

if exist "%~dp0pause.txt" pause

exit /B %ERR%
REM 
REM 
REM 
REM Tu[`Fsetup-db
REM 
:setup-db
call :log f[^x[XF%DB%쐬܂B
echo CREATE DATABASE IF NOT EXISTS `%DB%` CHARACTER SET UTF8; >> "%SCRIPT_FILE%"
echo SHOW DATABASES; >> "%SCRIPT_FILE%"
echo GRANT ALL ON `%DB%`.* TO %APP_USER% IDENTIFIED BY '%APP_USER_PASS%'; >> "%SCRIPT_FILE%"
echo GRANT FILE ON *.* TO %APP_USER%; >> "%SCRIPT_FILE%"
echo USE MYSQL; >> "%SCRIPT_FILE%"
echo SELECT HOST, USER, FILE_PRIV FROM USER; >> "%SCRIPT_FILE%"

set APP_USER=%ROOT_USER%
set APP_USER_PASS=%ROOT_USER_PASS%
set DB=

exit /B
REM 
REM 
REM 
REM Tu[`Fcreate-objects
REM 
:create-objects
call :log f[^x[XF%DB%Ƀe[u쐬܂B
for /F "usebackq" %%i in (`dir /B /ON script\tb*`) do (
	echo SOURCE script/%%i; >> "%SCRIPT_FILE%"
	call :retrive-tbl %%i
	echo DESCRIBE !TBL!; >> "%SCRIPT_FILE%"
)
echo show tables; >> "%SCRIPT_FILE%"
exit/B
REM 
REM 
REM 
REM Tu[`Fimport-master-data
REM 
:import-master-data
call :log f[^x[XF%DB%Ƀ}X^[f[^C|[g܂B
for /F "usebackq" %%i in (`dir /B /ON script\tbm*`) do (
	call :retrive-tbl %%i
	echo LOAD DATA LOCAL INFILE 'data/!TBL!.csv' INTO TABLE !TBL! CHARACTER SET sjis FIELDS TERMINATED BY ',' ENCLOSED BY '^"' LINES TERMINATED BY '\n'; >> "%SCRIPT_FILE%"
	echo SELECT CONCAT^('COUNT=', COUNT^(1^)^) AS !TBL! FROM !TBL!; >> "%SCRIPT_FILE%"
)
exit /B
REM 
REM 
REM 
REM Tu[`Fdrop-objects
REM 
:drop-objects
call :log f[^x[XF%DB%̃e[u폜܂B
for /F "usebackq" %%i in (`dir /B /O-N script\tb*`) do (
	call :retrive-tbl %%i
	echo DROP TABLE IF EXISTS !TBL!; >> "%SCRIPT_FILE%"
)
echo SHOW TABLES; >> "%SCRIPT_FILE%"
exit /B
REM 
REM 
REM 
REM Tu[`Fdelete-master-data
REM 
:delete-master-data
call :log f[^x[XF%DB%}X^[f[^폜܂B
for /F "usebackq" %%i in (`dir /B /O-N script\tbm*`) do (
	call :retrive-tbl %%i
	echo DELETE FROM !TBL!; >> "%SCRIPT_FILE%"
	echo SELECT CONCAT^('COUNT=', COUNT^(1^)^) AS !TBL! FROM !TBL!; >> "%SCRIPT_FILE%"
)
exit /B
REM 
REM 
REM 
REM Tu[`Fteardown-db
REM 
:teardown-db
call :log f[^x[XF%DB%폜܂B
echo DROP DATABASE `%DB%`; > "%SCRIPT_FILE%"
echo SHOW DATABASES; >> "%SCRIPT_FILE%"

set APP_USER=%ROOT_USER%
set APP_USER_PASS=%ROOT_USER_PASS%
set DB=

exit /B
REM 
REM 
REM 
REM Tu[`Fretrive-tbl
REM 
:retrive-tbl
set FL=%1
set TBL=%FL:.sql=%
set TBL=%TBL:~13%
exit /B


:log
echo ** %1
exit /B